

-- LilSparky's Workshop -- Addon for Slarti's Advanced Tradeskill Window mod for WOW
-- Lilsparky of Lothar
-- v0.1
-- oct.9.2007



LSW_AuctioneerHook = "auctioneer";


LSW_MINIMUM_REAGENT_AUCTIONS = 10
LSW_MINIMUM_ITEM_AUCTIONS = 1

LSW_itemFateColor={};
LSW_itemFateColor["d"]="ff008000";
LSW_itemFateColor["a"]="ff809060";
LSW_itemFateColor["v"]="ff206080";
LSW_itemFateColor["?"]="ff800000";

LSW_globalSync = 1;
LSW_skillPriceCache={};

LSW_globalFate = 0;
LSW_globalFateMax = 3;

ATSW_ShowWindow_ORIGINAL = nil;


-- these could certainly be made language specific if needed
LSW_itemFateList={};
LSW_itemFateList[1]="a";		-- auction
LSW_itemFateList[2]="v";		-- vendor
LSW_itemFateList[3]="d";		-- disenchant





function LSW_formatMoney(money,dark)
	local TEXT_NONE = "-- --"

	local GSC_GOLD="ffffd100"
	local GSC_SILVER="ffe6e6e6"
	local GSC_COPPER="ffc8602c"
	
	if (dark==1) then
		GSC_GOLD = "ff807000"
		GSC_SILVER = "ff808080"
		GSC_COPPER = "ff643016"
	end
	
	local g, s, c;
	local digits = 0
	
	g = math.floor(money/10000);
	s = math.fmod(math.floor(money/100),100);
	c = math.fmod(money,100);
	
	if (money > 0) then
		digits = math.floor(math.log10(money)+1)
	end
	
	if ( digits < 3 ) then
		gsc = string.format("   |c%s%2d|r",  GSC_COPPER, c);
	elseif ( digits < 5 ) then
		gsc = string.format("|c%s%2d|r |c%s%02d|r", GSC_SILVER, s, GSC_COPPER, c)
	elseif ( digits < 7 ) then
		gsc = string.format("|c%s%2d|r |c%s%02d|r", GSC_GOLD, g, GSC_SILVER, s)
	else
		gsc = string.format("|c%s%5d|r", GSC_GOLD, g);
	end

	return gsc
end

function LSW_findItemID(link)
	if ( type(link) ~= 'string' ) then return end
	local i,j,itemID = string.find(link, "|Hitem:(%d+):");	
-- DEFAULT_CHAT_FRAME:AddMessage("itemID - "..itemID);	
	return tonumber(itemID); 
end


function LSW_itemPriceVendor(link)
	local sell = 0
	local buy = 0
	local itemInfo = nil;
	
	local itemID = LSW_findItemID(link)
	
	if (itemID and itemID > 0) and (Informant) then
		itemInfo = Informant.GetItem(itemID)
	end
	if (not itemInfo) then return 0,0, true end

	buy = tonumber(itemInfo.buy) or 0
	sell = tonumber(itemInfo.sell) or 0

	return buy, sell, false
end


function LSW_itemPriceAuctioneer(link, minSeen) -- auctioneer version
	if (not Auctioneer or not link) then return 0, true; end

	if (not minSeen) then minSeen = 1 end;
	
-- DEFAULT_CHAT_FRAME:AddMessage(link);

	local itemKey = Auctioneer.ItemDB.CreateItemKeyFromLink(link);
	local dataMissing = false;
	
	local itemTotals = Auctioneer.HistoryDB.GetItemTotals(itemKey, auctKey);

	local sellPrice=0;
	
	if (not itemTotals) then
		return 0,0,true;
	end

-- DEFAULT_CHAT_FRAME:AddMessage(itemTotals.seenCount.." seen");
	if (itemTotals.seenCount < minSeen) then
		return 0, 0, true;
	else		
--		sellPrice  = Auctioneer.Statistic.GetMarketPrice(itemKey, auctKey);
		dummy, sellPrice  = Auctioneer.Statistic.GetHSP(itemKey, auctKey,1);
		dataMissing = false;		
	end
	
	return sellPrice, dataMissing;
end


function LSW_itemPriceAucAdvanced(link, minSeen) -- aucadvanced version (work in progress)
	local dataMissing = false;

	if (not link) then return 0, true; end
	
	if (not minSeen) then minSeen = 1; end

--	local itemTotals = Auctioneer.HistoryDB.GetItemTotals(itemKey, auctKey);

	local sellPrice=0;
	
--	if (not itemTotals) then
--		return 0,0,true;
--	end

--	if (itemTotals.seenCount < minSeen) then
--		return 0, 0, true;
--	else		
		sellPrice = AucAdvanced.API.GetMarketValue(link, AucAdvanced.GetFaction());
		if (not sellPrice) then
			dataMissing = true;
			sellPrice = 0
		end
--		dataMissing = false;		
--	end
	
	return sellPrice, dataMissing;
end


function LSW_itemValuation(skillName, skill)

	if (LSW_skillPriceCache[skillName] == nil) then
		LSW_skillPriceCache[skillName]={}
		LSW_skillPriceCache[skillName].sync = 0
		LSW_skillPriceCache[skillName].valueAmount = {};
	else
		if (LSW_skillPriceCache[skillName].sync == LSW_globalSync) then
			if (LSW_globalFate==0) then
				return LSW_skillPriceCache[skillName].costAmount, LSW_skillPriceCache[skillName].valueAmount[LSW_globalFate], LSW_skillPriceCache[skillName].itemFate;
			else
				return LSW_skillPriceCache[skillName].costAmount, LSW_skillPriceCache[skillName].valueAmount[LSW_globalFate], LSW_itemFateList[LSW_globalFate];
			end
		end
	end
	
	local cache = LSW_skillPriceCache[skillName];
	cache.synce = LSW_globalSync;
	cache.valueAmount[1] = 0;
	cache.valueAmount[2] = 0;
	cache.valueAmount[3] = 0;
	
	local sell = 0;
	local buy = 0;
	local stacks = 1;
	local itemFate = "?"
	
	local dummy;
		
	local skillLink = skill.link;
	
	local numReagents = ATSW_GetTradeSkillNumReagents(skill.id);

	for i=1, numReagents, 1 do
		local reagentName, x, reagentCount, y = ATSW_GetTradeSkillReagentInfo(skill.id, i);
		local reagentLink = ATSW_GetTradeSkillReagentItemLink(skill.id, i);
		
		local sellAtAuction;
		local buyFromVendor;
		local ahDataMissing;
		
		local reagentValue;
		
		sellAtAuction, ahDataMissing = LSW_itemPrice(reagentLink, LSW_MININUM_REAGENT_AUCTIONS);
		buyFromVendor = LSW_itemPriceVendor(reagentLink);

-- calculate the cost of reagents.  if ah data exists, use it.  if no ah data exists then use the buy from vendor price

		if (ahDataMissing) then
			reagentValue = buyFromVendor;
		else
			reagentValue = sellAtAuction;
		end
		
		buy = buy + reagentValue * reagentCount;
	end
		
	cache.costAmount = buy;  -- costAmount = how much it would cost to purchase the reagents
	
	if (GetItemInfo(skillLink)) then  -- items return info, enchants return nil
		local min,max = GetTradeSkillNumMade(skill.id);
-- DEFAULT_CHAT_FRAME:AddMessage(skillName.."  "..min.." "..max);

		stacks = min+max/2;
	
		sell = LSW_itemPrice(skillLink, LSW_MINIUMUM_ITEM_AUCTIONS);
		cache.valueAmount[1] = sell * stacks;  -- valueAmount[1] = how much an item might auction for
	
		dummy, sell = LSW_itemPriceVendor(skillLink);
		cache.valueAmount[2] = sell * stacks;  -- valueAmount[2] = how much an item would sell to a vendor for
	
-- DEFAULT_CHAT_FRAME:AddMessage(skill.type);
	
		if (LSW_AuctioneerHook == "auctioneer") then
			if (Enchantrix) then
				sell = Enchantrix.Storage.GetItemDisenchantTotals(skillLink); -- auctioneer
			else
				sell = 0;
			end
		else
			if (Enchantrix) then
				dummy, dummy, dummy, sell = Enchantrix.Storage.GetItemDisenchantTotals(skillLink); -- aucadvanced
			else
				sell = 0
			end
		end
	end
	
	if (sell) then
		cache.valueAmount[3] = sell * stacks;  -- valueAmount[3] = how much an item would sell for if de'd
	end
	
	
	if (cache.valueAmount[1] > cache.valueAmount[2] and cache.valueAmount[1] > cache.valueAmount[3]) then
		cache.valueAmount[0] = cache.valueAmount[1];
		cache.itemFate = LSW_itemFateList[1];
	else
		if (cache.valueAmount[2] > cache.valueAmount[3] and cache.valueAmount[2] > cache.valueAmount[1]) then
			cache.valueAmount[0] = cache.valueAmount[2];
			cache.itemFate = LSW_itemFateList[2];
		else
			cache.valueAmount[0] = cache.valueAmount[3];
			cache.itemFate = LSW_itemFateList[3];
		end
	end
	
	LSW_skillPriceCache[skillName].sync = LSW_globalSync;
				
	if (LSW_globalFate==0) then
		return LSW_skillPriceCache[skillName].costAmount, LSW_skillPriceCache[skillName].valueAmount[LSW_globalFate], LSW_skillPriceCache[skillName].itemFate;
	else
		return LSW_skillPriceCache[skillName].costAmount, LSW_skillPriceCache[skillName].valueAmount[LSW_globalFate], LSW_itemFateList[LSW_globalFate];
	end
end



function LSW_SkillShow()

if (AucAdvanced) then
		LSW_AuctioneerHook = "aucadv"
		LSW_itemPrice = LSW_itemPriceAucAdvanced
	else
		LSW_AuctioneerHook = "auctioneer"
		LSW_itemPrice = LSW_itemPriceAuctioneer
	end


	if(ATSWListScrollFrame:IsVisible()) then
		this:SetWidth(223);
	else
		this:SetWidth(243);
	end
				
	local name = this:GetName();
	local id = string.sub(name,10);
	local itemLevel = "?";
	local x;
	local buttonLevel = getglobal("ATSWTradeSkillItemLevel"..id);
	local buttonCost = getglobal("ATSWTradeSkillCost"..id);
	local buttonValue = getglobal("ATSWTradeSkillValue"..id);

--	DEFAULT_CHAT_FRAME:AddMessage("show "..this:GetName().."  id:"..id);
	
	local tradeskillid=this:GetID();
	local listpos=ATSW_GetSkillListingPos(tradeskillid);
	
	if(atsw_skilllisting[listpos]) then
		local skillName = atsw_skilllisting[listpos].name;
		local skillLink = atsw_skilllisting[listpos].link;
		local skillType = atsw_skilllisting[listpos].type;
		
		if (skillType ~= "header") then						
			local costAmount, valueAmount, itemFate = LSW_itemValuation(skillName, atsw_skilllisting[listpos]);
						
			local itemFateString = string.format("|c%s%s|r", LSW_itemFateColor[itemFate], itemFate);
						
			if (costAmount < valueAmount) then
				buttonValue:SetText(LSW_formatMoney(valueAmount,0)..itemFateString);
				buttonCost:SetText(LSW_formatMoney(costAmount,1).."  ");
			else
				buttonValue:SetText(LSW_formatMoney(valueAmount,1)..itemFateString);
				buttonCost:SetText(LSW_formatMoney(costAmount,1).."  ");
			end
					
				
		
			if (skillLink and skillName and skillName ~= "") then		
				x, x, x, x, itemLevel = GetItemInfo(skillLink);
			
				
				if (itemLevel) and (itemLevel <= UnitLevel("player")) then
					buttonLevel:SetTextColor(.8,.8,.8);
				else
					buttonLevel:SetTextColor(1,.2,.2);
				end
			end
			
			if (itemLevel == 0) then
				itemLevel = "1"
			end
			
			if (itemLevel) then
				buttonLevel:SetText(itemLevel);
				buttonLevel:Show();
				buttonValue:Show();
			else
				buttonLevel:SetText("");
				buttonLevel:Hide();
			end
		
			buttonCost:Show();
		end
	end
	
end


function LSW_SkillHide()
	local name = this:GetName();
	local id = string.sub(name,10);
	
	local buttonCost = getglobal("ATSWTradeSkillCost"..id);
	local buttonValue = getglobal("ATSWTradeSkillValue"..id);
	local buttonLevel = getglobal("ATSWTradeSkillItemLevel"..id);

	buttonCost:Hide();
	buttonValue:Hide();
	buttonLevel:Hide();
end




function LSW_ItemLevelButton_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);
	GameTooltip:SetText("Required level to use crafted item.");
	GameTooltip:Show();
end

function LSW_ItemLevelButton_OnLeave()
	GameTooltip:Hide();
end



function LSW_CostButton_OnEnter()
-- DEFAULT_CHAT_FRAME:AddMessage("skill cost enter");
   	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);
	GameTooltip:SetText("Estimated cost to use skill.");
	GameTooltip:Show();
end

function LSW_CostButton_OnLeave()
	GameTooltip:Hide();
end


-- click on the value and toggle the BEST/AUCTION/VENDOR/DE price consideration

function LSW_ValueButton_OnClick(button)
	if(button=="LeftButton") then
		LSW_globalFate = LSW_globalFate + 1;
		
		if (LSW_globalFate > LSW_globalFateMax) then
			LSW_globalFate = 0;
		end
		
		LSW_ValueButton_OnEnter()
		ATSWFrame_Update();
	end
end

function LSW_ValueButton_OnEnter()
-- DEFAULT_CHAT_FRAME:AddMessage("skill value enter");
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);
	
	if (LSW_globalFate == 0) then
		GameTooltip:SetText("Estimated value of crafted item(s).");
		GameTooltip:AddLine("Best price shown.");
		GameTooltip:AddLine("a = auction  v = vendor  d = disenchant");
	elseif (LSW_globalFate == 1) then
		GameTooltip:SetText("Estimated auction value of crafted item(s).");
	elseif (LSW_globalFate == 2) then
		GameTooltip:SetText("Vendor purchase price of crafted item(s).");
	else
		GameTooltip:SetText("Estimated disenchant value of crafted item(s).");
	end
	
	GameTooltip:Show();
end

function LSW_ValueButton_OnLeave()
	GameTooltip:Hide();
end


function LSW_ShowWindow()
	LSW_globalSync = LSW_globalSync + 1;
	ATSW_ShowWindow_ORIGINAL()
	
	local ATSW_title = ATSWFrameTitleText:GetText();
	ATSWFrameTitleText:SetText(ATSW_title.." (LilSparky's Workshop Enhanced)");
	ATSWFrame_Update();
end


function LSW_OnLoad()
	DEFAULT_CHAT_FRAME:AddMessage("LilSparky's Workshop v0.1");
	if (not Auctioneer) and (not AucAdvanced) then
		DEFAULT_CHAT_FRAME:AddMessage("ERROR: LilSparky's Workshop requires either Auctioneer or AuctioneerAdvanced to funtion properly.");
		return;
	end
	
	if (AucAdvanced) then
		LSW_AuctioneerHook = "aucadv"
		LSW_itemPrice = LSW_itemPriceAucAdvanced
	else
		LSW_AuctioneerHook = "auctioneer"
		LSW_itemPrice = LSW_itemPriceAuctioneer
	end
	
	if (Enchantrix) then
		LSW_globalFateMax = 3
	else
		DEFAULT_CHAT_FRAME:AddMessage("WARNING: LilSparky's Workshop needs Enchantrix to calculate disenchant values.");
		DEFAULT_CHAT_FRAME:AddMessage("Addon will still work, but no disenchant values will be calculated.");
		LSW_globalFateMax = 2
	end
		
	ATSW_ShowWindow_ORIGINAL = ATSW_ShowWindow;
	ATSW_ShowWindow = LSW_ShowWindow
	
	for i=1, 23, 1 do
		local atswButton = getglobal("ATSWSkill"..i);
		atswButton:SetScript("OnShow", LSW_SkillShow);
		atswButton:SetScript("OnHide", LSW_SkillHide);	
		atswButton:SetTextFontObject("GameFontNormalSmall");
		atswButton:SetHighlightFontObject("GameFontHighlightSmall");
		atswButton:SetDisabledFontObject("GameFontDisableSmall");
	
	
		local buttonValue = getglobal("ATSWTradeSkillValue"..i);
		buttonValue:SetParent("ATSWFrame");
		buttonValue:SetPoint("TOPLEFT","ATSWSkill"..i,"TOPRIGHT",5,0);
		buttonValue:SetText("00 00");
		buttonValue:SetWidth(30);
		buttonValue:Hide();
	
	
		local buttonCost = getglobal("ATSWTradeSkillCost"..i);
		buttonCost:SetParent("ATSWFrame");
		buttonCost:SetPoint("TOPLEFT","ATSWTradeSkillValue"..i,"TOPRIGHT",15,0);
		buttonCost:SetText("00 00");
		buttonCost:SetWidth(30);
		buttonCost:Hide();
	

		local buttonLevel = getglobal("ATSWTradeSkillItemLevel"..i);
		buttonLevel:SetParent("ATSWFrame");
		buttonLevel:SetPoint("TOPLEFT","ATSWSkill"..i,"TOPLEFT",0,0);
		buttonLevel:SetText("");
		buttonLevel:Hide();
	
	end

end


